// Выполняем скрипт только после того, как все загружено, включая картинки
var treeView = class treeViewClass {
    constructor(containerId, fileURL, fileEncode = '', openClose, parseType = 'xml') {
        if (parseType != 'json' && parseType != 'xml') return;

        // Получение контейнера для отображения дерева
        let container = document.getElementById(containerId); 
        
        function iterateJson(o) {
            var delim = [];
            var s = '';
            for(var a in o) {

                if (o[a].constructor.name === 'Object') delim = ['{', '}'];
                if (o[a].constructor.name === 'Array') delim = ['[', ']'];
                if (o[a].constructor.name === 'Object' || o[a].constructor.name === 'Array') { 
                    s += '<ul>';
                    var aa = (isNaN(Number(a)) === true) ? '"'+a+'": ' : '';
                    s += '<li><details '+openClose+'><summary>'+aa+delim[0]+'</summary>';
                    //console.log('Продолжаем: ', 'Тип поля:', o[a].constructor.name , 'Наименование поля:', a, 'Значение поля:', o[a]);
                    s += iterateJson(o[a]);
                    s += delim[1]+'</details></li></ul>';
                } else {
                    //console.log('Конец: ', 'Тип поля:', o[a].constructor.name , 'Наименование поля:', a, 'Значение поля:', o[a]);
                    var aa = (isNaN(Number(a)) === true) ? '"<span>'+a+'": ' : '';
                    s += '&nbsp;&nbsp;&nbsp;&nbsp;'+aa+'"<font color=gray>'+o[a]+'</font>"</span><br>';
                }
            }

            return s;
        }

        // Парсинг JSON-файла в объект
        function parseJson(json) {
            let jsonObj = JSON.parse(json);

            if (typeof jsonObj != 'undefined' && Object.keys(jsonObj).length > 0) {
                return iterateJson(jsonObj);
            } else {
                return false;
            }
        }
        
        // Парсинг XML-файла в объект
        function parseXml(xml, arrayTags) {
            let dom = null;
            if (window.DOMParser) dom = (new DOMParser()).parseFromString(xml, "text/xml");
            else if (window.ActiveXObject) {
                dom = new ActiveXObject('Microsoft.XMLDOM');
                dom.async = false;
                if (!dom.loadXML(xml)) throw dom.parseError.reason + " " + dom.parseError.srcText;
            }
            else throw new Error("Не получается распарсить XML!");
            function parseNode(xmlNode, result) {
                if (xmlNode.nodeName == "#text") {
                    let v = xmlNode.nodeValue;
                    if (v.trim()) result['Значение'] = v;
                    return;
                }
                let jsonNode = {},
                    existing = result[xmlNode.nodeName];
                if (existing) {
                    if (!Array.isArray(existing)) result[xmlNode.nodeName] = [existing, jsonNode];
                    else result[xmlNode.nodeName].push(jsonNode);
                }
                else {
                    if (arrayTags && arrayTags.indexOf(xmlNode.nodeName) != -1) result[xmlNode.nodeName] = [jsonNode];
                    else result[xmlNode.nodeName] = jsonNode;
                }
                if (xmlNode.attributes) for (let attribute of xmlNode.attributes) jsonNode[attribute.nodeName] = attribute.nodeValue;
                for (let node of xmlNode.childNodes) parseNode(node, jsonNode);
            }
            let result = {};
            for (let node of dom.childNodes) parseNode(node, result);
            return result;
        }    
        // Построение дерева с использованием тегов ul и li из объекта
        function iterateObj(o){

            var s = '';
            for (var a in o) {
                if (typeof o[a] == 'object') {
                    s += '<ul>';
                    s += '<li><details '+openClose+'><summary>'+a+'</summary>';
                    s += iterateObj(o[a]);
                    s += '</details></li></ul>';
                } else {
                    s += '&nbsp;&nbsp;&nbsp;&nbsp;<span>'+a+'=<font color=gray>"'+o[a]+'"</font></span>';
                }  
            }

            return s;
        }
        // Получаем файл и выводим дерево
        fetch(fileURL)
        .then((response) => 
            response.arrayBuffer()
        )
        .then((buffer) => {
            // Получаем кодировку для переменной fileEncode
            var strBuffer = new TextDecoder().decode(new Uint8Array(buffer));

            var setRegExp = /encoding="(.*?)"/g;
            var matches = [];
            while (setRegExp.exec(strBuffer)) {
                matches.push(RegExp.$1);
            }
            if (typeof matches[0] != 'undefined' && matches[0] != '' && fileEncode == '') fileEncode = matches[0];

            if (parseType == 'xml' && fileEncode == '') fileEncode = 'utf-8';
            if (parseType == 'json' && fileEncode == '') fileEncode = 'utf-8';

            // Получаем XML в виде объекта
            let html = (fileEncode == '') ? new TextDecoder().decode(buffer) : new TextDecoder(fileEncode).decode(buffer);
            let htmlObj = (parseType == 'xml') ? parseXml(html) : parseJson(html);
            // Выводим рекурсивно объект в виде HTML дерева с использование тегов ul и li
            var htmls = (parseType == 'xml') ? iterateObj(htmlObj) : htmlObj;
            container.innerHTML = htmls;
        });
    }
} 